#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"
#include "globals.hpp" // freelist list1 list2
#include "consumer.hpp"

int consume(block* c);

void *consumer (void *) {
   while (true) {
      sem_wait(&seml2); // decrease seml2
      sem_wait(&mutl2);
      block* c = list_unlink(list2);
      sem_post(&mutl2);
      //* consume information in block c
      consume(c);
      sem_wait(&mutfl);
      list_link(freelist, c);
      sem_post(&mutfl);
      sem_post(&semfl); // increase freelist
   }
   return nullptr;
}

int consume(block *c) {
   c->data = -c->data;
   usleep(75);
   return 0;
}
